'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _DropdownComponents = require('./DropdownComponents');

var _TextFieldComponents = require('../TextField/TextFieldComponents');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _ref = _react2.default.createElement(
  _DropdownComponents.Option,
  null,
  'No results'
);

var Dropdown = function (_Component) {
  (0, _inherits3.default)(Dropdown, _Component);

  function Dropdown(props) {
    (0, _classCallCheck3.default)(this, Dropdown);

    var _this = (0, _possibleConstructorReturn3.default)(this, (Dropdown.__proto__ || (0, _getPrototypeOf2.default)(Dropdown)).call(this, props));

    _this.handleToggle = function () {
      _this.setState({
        isOpen: !_this.state.isOpen
      });
    };

    _this.select = function (value) {
      _this.setState({
        value: value,
        isOpen: false
      });
    };

    _this.handleMaskClick = function () {
      _this.setState({
        isOpen: false
      });
    };

    _this.state = {
      isOpen: false,
      value: null
    };
    return _this;
  }

  (0, _createClass3.default)(Dropdown, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          label = _props.label,
          data = _props.data,
          width = _props.width;
      var _state = this.state,
          isOpen = _state.isOpen,
          value = _state.value;

      return _react2.default.createElement(
        _DropdownComponents.DropdownContainer,
        { width: width },
        _react2.default.createElement(_DropdownComponents.Mask, { show: isOpen, onClick: this.handleMaskClick }),
        label && _react2.default.createElement(
          _TextFieldComponents.Label,
          null,
          label
        ),
        _react2.default.createElement(_DropdownComponents.Select, (0, _extends3.default)({ isOpen: isOpen, value: value }, this.props, { onClick: this.handleToggle })),
        _react2.default.createElement(
          _DropdownComponents.OptionsContainer,
          { size: data.length, hasLabel: !!label, show: isOpen },
          _react2.default.createElement(
            _DropdownComponents.OptionsScrollContainer,
            null,
            data.length < 1 && _ref,
            data.map(function (d) {
              return _react2.default.createElement(
                _DropdownComponents.Option,
                { data: d, onClick: function onClick() {
                    return _this2.select(d);
                  } },
                d.name
              );
            })
          )
        )
      );
    }
  }]);
  return Dropdown;
}(_react.Component);

Dropdown.propTypes = process.env.NODE_ENV !== "production" ? {
  data: _propTypes2.default.array.isRequired,
  label: _propTypes2.default.string,
  placeholder: _propTypes2.default.string,
  width: _propTypes2.default.string
} : {};

Dropdown.defaultProps = {
  data: [],
  placeholder: 'Choose'
};

exports.default = Dropdown;