'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Mask = exports.DropdownContainer = exports.OptionsScrollContainer = exports.OptionsContainer = exports.Option = exports.Select = undefined;

var _taggedTemplateLiteral2 = require('babel-runtime/helpers/taggedTemplateLiteral');

var _taggedTemplateLiteral3 = _interopRequireDefault(_taggedTemplateLiteral2);

var _templateObject = (0, _taggedTemplateLiteral3.default)(['\n  flex-grow: 1;\n  padding-left: ', 'px;\n  padding-top: ', 'px;\n  padding-bottom: ', 'px;\n  user-select: none;\n'], ['\n  flex-grow: 1;\n  padding-left: ', 'px;\n  padding-top: ', 'px;\n  padding-bottom: ', 'px;\n  user-select: none;\n']),
    _templateObject2 = (0, _taggedTemplateLiteral3.default)(['\n  transform: ', ';\n  display: flex;\n  align-items: center;\n  padding: ', 'px ', 'px;\n  user-select: none;\n  color: ', ';\n'], ['\n  transform: ', ';\n  display: flex;\n  align-items: center;\n  padding: ', 'px ', 'px;\n  user-select: none;\n  color: ', ';\n']),
    _templateObject3 = (0, _taggedTemplateLiteral3.default)(['\n  cursor: arrow;\n  display: flex;\n  position: relative;\n  min-width: 100px;\n  height: ', 'px;\n  border-width: 1px;\n  border-style: solid;\n  border-color: ', ';\n  border-radius: 4px;\n  background-color: ', ';\n  &:hover {\n    border-color:', '\n  }\n'], ['\n  cursor: arrow;\n  display: flex;\n  position: relative;\n  min-width: 100px;\n  height: ', 'px;\n  border-width: 1px;\n  border-style: solid;\n  border-color: ', ';\n  border-radius: 4px;\n  background-color: ', ';\n  &:hover {\n    border-color:', '\n  }\n']),
    _templateObject4 = (0, _taggedTemplateLiteral3.default)(['\n  flex: 1;\n  padding-top: ', 'px;\n  padding-bottom: ', 'px;\n  :first-child {\n    padding-top: 0;\n  }\n  :last-child {\n    padding-bottom: 0;\n  }\n'], ['\n  flex: 1;\n  padding-top: ', 'px;\n  padding-bottom: ', 'px;\n  :first-child {\n    padding-top: 0;\n  }\n  :last-child {\n    padding-bottom: 0;\n  }\n']),
    _templateObject5 = (0, _taggedTemplateLiteral3.default)(['\n  z-index: 100;\n  position: absolute;\n  height: ', '\n  top: ', 'px;\n  width: 100%;\n  background-color: ', ';\n  display: ', ';\n  border-width: 1px;\n  border-style: solid;\n  border-color: ', ';\n  border-radius: 4px;\n'], ['\n  z-index: 100;\n  position: absolute;\n  height: ', '\n  top: ', 'px;\n  width: 100%;\n  background-color: ', ';\n  display: ', ';\n  border-width: 1px;\n  border-style: solid;\n  border-color: ', ';\n  border-radius: 4px;\n']),
    _templateObject6 = (0, _taggedTemplateLiteral3.default)(['\n  flex-grow: 1;\n  overflow-y: auto;\n  margin: ', 'px ', 'px;\n  /* width */\n  ::-webkit-scrollbar {\n      width: 4px;\n  }\n\n  /* Track */\n  ::-webkit-scrollbar-track {\n      background: ', ';\n      border-radius: 4px;\n  }\n  \n  /* Handle */\n  ::-webkit-scrollbar-thumb {\n      background: ', '; \n      border-radius: 4px;\n  }\n'], ['\n  flex-grow: 1;\n  overflow-y: auto;\n  margin: ', 'px ', 'px;\n  /* width */\n  ::-webkit-scrollbar {\n      width: 4px;\n  }\n\n  /* Track */\n  ::-webkit-scrollbar-track {\n      background: ', ';\n      border-radius: 4px;\n  }\n  \n  /* Handle */\n  ::-webkit-scrollbar-thumb {\n      background: ', '; \n      border-radius: 4px;\n  }\n']),
    _templateObject7 = (0, _taggedTemplateLiteral3.default)(['\n  position: relative;\n  width: ', ';\n  margin: ', 'px;\n'], ['\n  position: relative;\n  width: ', ';\n  margin: ', 'px;\n']),
    _templateObject8 = (0, _taggedTemplateLiteral3.default)(['\n  position: fixed;\n  display: ', ';\n  top: 0;\n  left: 0;\n  right: 0;\n  bottom: 0;\n'], ['\n  position: fixed;\n  display: ', ';\n  top: 0;\n  left: 0;\n  right: 0;\n  bottom: 0;\n']);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reset = require('../reset');

var reset = _interopRequireWildcard(_reset);

var _Body = require('../Text/Body');

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Select = exports.Select = function Select(props) {
  return _react2.default.createElement(
    SelectBox,
    { onClick: props.onClick },
    _react2.default.createElement(
      Placeholder,
      null,
      props.value && props.value.name || props.placeholder
    ),
    _react2.default.createElement(
      ArrowContainer,
      props,
      '\u25B2'
    )
  );
};

Select.propTypes = process.env.NODE_ENV !== "production" ? {
  onClick: _propTypes2.default.func,
  placeholder: _propTypes2.default.string,
  value: _propTypes2.default.object
} : {};

var Placeholder = _Body.BodyComponent.extend(_templateObject, function (p) {
  return p.theme.dropdown.paddingHorizontal;
}, function (p) {
  return p.theme.dropdown.paddingVertical;
}, function (p) {
  return p.theme.dropdown.paddingVertical;
});

var ArrowContainer = reset.div(_templateObject2, function (p) {
  return p.isOpen ? '' : 'rotate(180deg)';
}, function (p) {
  return p.theme.dropdown.paddingVertical;
}, function (p) {
  return p.theme.dropdown.paddingHorizontal;
}, function (p) {
  return p.theme.colors.grey400;
});

var SelectBox = reset.div(_templateObject3, function (p) {
  return p.theme.text.body.lineHeight + p.theme.dropdown.paddingVertical * 2;
}, function (props) {
  if (props.disabled) {
    return props.theme.dropdown.disabled.borderColor;
  }
  if (props.error) {
    return props.theme.dropdown.error.borderColor;
  }
  if (props.isFocused) {
    return props.theme.dropdown.focus.borderColor;
  }
  return props.theme.dropdown.borderColor;
}, function (props) {
  return props.theme.colors.white;
}, function (props) {
  if (props.error || props.disabled || props.isFocused) return '';
  return props.theme.dropdown.hover.borderColor;
});

var Option = exports.Option = _Body.BodyComponent.extend(_templateObject4, function (p) {
  return p.theme.dropdown.paddingVertical;
}, function (p) {
  return p.theme.dropdown.paddingVertical;
});

var OptionsContainer = exports.OptionsContainer = reset.div(_templateObject5, function (p) {
  var size = p.size;
  if (p.size > 3) {
    size = 3;
  } else if (p.size < 1) {
    size = 1;
  }
  return (p.theme.text.body.lineHeight + p.theme.dropdown.paddingVertical * 2) * size + 2 + 'px';
}, function (p) {
  return p.theme.text.body.lineHeight + p.theme.dropdown.paddingVertical * 2 + 6 + (p.hasLabel && 30);
}, function (p) {
  return p.theme.colors.white;
}, function (p) {
  return p.show ? 'flex' : 'none';
}, function (props) {
  return props.theme.dropdown.borderColor;
});

var OptionsScrollContainer = exports.OptionsScrollContainer = reset.div(_templateObject6, function (p) {
  return p.theme.dropdown.paddingVertical;
}, function (p) {
  return p.theme.dropdown.paddingHorizontal;
}, function (p) {
  return p.theme.colors.grey200;
}, function (p) {
  return p.theme.colors.grey400;
});

var DropdownContainer = exports.DropdownContainer = reset.div(_templateObject7, function (p) {
  return p.width;
}, function (p) {
  return p.theme.spacing.marginVertical;
});

var Mask = exports.Mask = reset.div(_templateObject8, function (p) {
  return p.show ? 'block' : 'none';
});