'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.UnderlinedLinkContainer = undefined;

var _taggedTemplateLiteral2 = require('babel-runtime/helpers/taggedTemplateLiteral');

var _taggedTemplateLiteral3 = _interopRequireDefault(_taggedTemplateLiteral2);

var _templateObject = (0, _taggedTemplateLiteral3.default)(['\n  font-size: ', 'px;\n  line-height: ', 'px;\n'], ['\n  font-size: ', 'px;\n  line-height: ', 'px;\n']),
    _templateObject2 = (0, _taggedTemplateLiteral3.default)(['\n  display: inline-block;\n  padding-bottom: ', 'px;\n  ', '\n  ', '\n'], ['\n  display: inline-block;\n  padding-bottom: ', 'px;\n  ', '\n  ', '\n']),
    _templateObject3 = (0, _taggedTemplateLiteral3.default)(['\n  width: ', ';\n  height: 1px;\n  background-color: ', ';\n'], ['\n  width: ', ';\n  height: 1px;\n  background-color: ', ';\n']),
    _templateObject4 = (0, _taggedTemplateLiteral3.default)(['\n  font-family: ', ';\n  margin-top: ', 'px;\n  margin-bottom: ', 'px;\n  color: ', ';\n  display: block;\n  ', '\n'], ['\n  font-family: ', ';\n  margin-top: ', 'px;\n  margin-bottom: ', 'px;\n  color: ', ';\n  display: block;\n  ', '\n']);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _styledComponents = require('styled-components');

var _reset = require('../reset');

var reset = _interopRequireWildcard(_reset);

var _colors = require('../../Tokens/base/colors');

var _colors2 = _interopRequireDefault(_colors);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var regularStyle = (0, _styledComponents.css)(_templateObject, function (p) {
  return p.theme.text.body.fontSize;
}, function (p) {
  return p.theme.text.body.lineHeight;
});

var largeStyle = (0, _styledComponents.css)(_templateObject, function (p) {
  return p.theme.text.navigation.fontSize;
}, function (p) {
  return p.theme.text.navigation.lineHeight;
});
var UnderlinedLinkContainer = exports.UnderlinedLinkContainer = function UnderlinedLinkContainer(props) {
  return _react2.default.createElement(
    UnderlinedLinkComponent,
    null,
    _react2.default.createElement(Text, props),
    props.variation !== 'large' && _react2.default.createElement(Line, { variation: props.variation, color: props.borderColor })
  );
};

UnderlinedLinkContainer.propTypes = process.env.NODE_ENV !== "production" ? {
  /**
   * Underline color if underlined
   */
  borderColor: _propTypes2.default.string,
  /**
   * Label
   */
  children: _propTypes2.default.node.isRequired,
  /**
   * Regular or small UnderlinedLink.
   */
  variation: _propTypes2.default.oneOf(['large', 'regular'])
} : {};

var Text = reset.div(_templateObject2, function (p) {
  return p.theme.spacing.gap;
}, function (props) {
  return props.variation === 'large' ? largeStyle : regularStyle;
}, function (p) {
  return p.variation === 'large' && 'border-bottom: 1px solid ' + p.borderColor + ';';
});

var Line = reset.div(_templateObject3, function (p) {
  return p.variation === 'large' ? '100%' : '54px';
}, function (p) {
  return p.color;
});

var UnderlinedLinkComponent = reset.div(_templateObject4, function (p) {
  return p.theme.text.fontFamily;
}, function (p) {
  return p.theme.spacing.marginVertical;
}, function (p) {
  return p.theme.spacing.marginVertical;
}, function (p) {
  return p.theme.text.color;
}, function (props) {
  return props.variation === 'large' ? largeStyle : regularStyle;
});

var UnderlinedLink = function UnderlinedLink(props) {
  return _react2.default.createElement(UnderlinedLinkContainer, props);
};

UnderlinedLink.propTypes = process.env.NODE_ENV !== "production" ? {
  /**
   * Underline color if underlined
   */
  borderColor: _propTypes2.default.string,
  /**
   * Label
   */
  children: _propTypes2.default.node.isRequired,
  /**
   * Regular or small UnderlinedLink.
   */
  variation: _propTypes2.default.oneOf(['large', 'regular'])
} : {};

UnderlinedLink.defaultProps = {
  variation: 'regular',
  noWrap: false,
  align: 'inherit',
  wholeLine: false,
  borderColor: _colors2.default.brand100
};

exports.default = UnderlinedLink;