'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var SvgWrapper = function SvgWrapper(_ref) {
  var width = _ref.width,
      height = _ref.height,
      title = _ref.title,
      desc = _ref.desc,
      children = _ref.children,
      viewBox = _ref.viewBox;
  return _react2.default.createElement(
    'svg',
    { width: width, height: height, viewBox: viewBox },
    _react2.default.createElement(
      'title',
      null,
      title
    ),
    _react2.default.createElement(
      'desc',
      null,
      desc
    ),
    children
  );
};

SvgWrapper.propTypes = process.env.NODE_ENV !== "production" ? {
  /**
   * SVG content
   */
  children: _propTypes2.default.node.isRequired,
  /**
   * SVG description
   */
  desc: _propTypes2.default.string,
  /**
   * Height of svg
   */
  height: _propTypes2.default.number,
  /**
   * SVG title
   */
  title: _propTypes2.default.string,
  /**
   * View Box of svg
   */
  viewBox: _propTypes2.default.string,
  /**
   * Width of svg
   */
  width: _propTypes2.default.number
} : {};

SvgWrapper.defaultProps = {
  width: '50',
  height: '50'
};

exports.default = SvgWrapper;