'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _TextFieldComponents = require('./TextFieldComponents');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var TextField = function (_React$Component) {
  (0, _inherits3.default)(TextField, _React$Component);

  function TextField() {
    var _ref;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, TextField);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = TextField.__proto__ || (0, _getPrototypeOf2.default)(TextField)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      inputFocused: false
    }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  (0, _createClass3.default)(TextField, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          label = _props.label,
          caption = _props.caption,
          onChange = _props.onChange,
          toggle = _props.toggle,
          error = _props.error,
          link = _props.link,
          onToggle = _props.onToggle,
          disabled = _props.disabled,
          theme = _props.theme,
          type = _props.type,
          value = _props.value;
      var inputFocused = this.state.inputFocused;

      return _react2.default.createElement(
        _TextFieldComponents.TextFieldComponent,
        null,
        label && _react2.default.createElement(
          _TextFieldComponents.Label,
          null,
          label
        ),
        caption && _react2.default.createElement(
          _TextFieldComponents.Caption,
          null,
          caption
        ),
        _react2.default.createElement(
          _TextFieldComponents.TextInputContainer,
          {
            isFocused: inputFocused,
            theme: theme,
            disabled: disabled,
            error: error
          },
          _react2.default.createElement(_TextFieldComponents.TextInput, {
            value: value,
            type: type,
            onChange: onChange,
            disabled: disabled,
            onFocus: function onFocus() {
              return _this2.setState({ inputFocused: true });
            },
            onBlur: function onBlur() {
              return _this2.setState({ inputFocused: false });
            }
          }),
          toggle && _react2.default.createElement(
            _TextFieldComponents.Toggle,
            { onClick: onToggle },
            toggle
          )
        ),
        error && _react2.default.createElement(
          _TextFieldComponents.ErrorText,
          null,
          error
        ),
        link && _react2.default.createElement(
          _TextFieldComponents.Link,
          { href: link.href, wholeLine: true, variation: 'small' },
          link.label
        )
      );
    }
  }]);
  return TextField;
}(_react2.default.Component);

TextField.propTypes = process.env.NODE_ENV !== "production" ? {
  caption: _propTypes2.default.string,
  disabled: _propTypes2.default.bool,
  error: _propTypes2.default.string,
  label: _propTypes2.default.string,
  link: _propTypes2.default.shape({
    label: _propTypes2.default.string,
    href: _propTypes2.default.string
  }),
  onChange: _propTypes2.default.func,
  onToggle: _propTypes2.default.func,
  theme: _propTypes2.default.object,
  toggle: _propTypes2.default.string,
  type: _propTypes2.default.string,
  value: _propTypes2.default.string
} : {};

TextField.defaultProps = {
  label: null,
  error: null,
  link: null,
  caption: null,
  type: 'text'
};

exports.default = TextField;