'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.TextFieldComponent = exports.TextInput = exports.TextInputContainer = exports.Link = exports.Caption = exports.ErrorText = exports.Toggle = exports.Label = undefined;

var _taggedTemplateLiteral2 = require('babel-runtime/helpers/taggedTemplateLiteral');

var _taggedTemplateLiteral3 = _interopRequireDefault(_taggedTemplateLiteral2);

var _templateObject = (0, _taggedTemplateLiteral3.default)(['\n  color: ', ';\n  margin-bottom: 6px;\n  font-weight: bold;\n  padding: 0;\n'], ['\n  color: ', ';\n  margin-bottom: 6px;\n  font-weight: bold;\n  padding: 0;\n']),
    _templateObject2 = (0, _taggedTemplateLiteral3.default)(['\n  color: ', ';\n  cursor: pointer;\n  text-decoration: underline;\n  padding-left: 18px;\n  padding-right: 18px;\n'], ['\n  color: ', ';\n  cursor: pointer;\n  text-decoration: underline;\n  padding-left: 18px;\n  padding-right: 18px;\n']),
    _templateObject3 = (0, _taggedTemplateLiteral3.default)(['\n  color: ', ';\n'], ['\n  color: ', ';\n']),
    _templateObject4 = (0, _taggedTemplateLiteral3.default)(['\n  padding: 0;\n  margin-bottom: 6px;\n'], ['\n  padding: 0;\n  margin-bottom: 6px;\n']),
    _templateObject5 = (0, _taggedTemplateLiteral3.default)([''], ['']),
    _templateObject6 = (0, _taggedTemplateLiteral3.default)(['\n  display: flex;\n  height: ', 'px;\n  border-width: 1px;\n  border-style: solid;\n  border-color: ', ';\n  border-radius: 4px;\n  background-color: ', ';\n  &:hover {\n    border-color:', '\n  }\n'], ['\n  display: flex;\n  height: ', 'px;\n  border-width: 1px;\n  border-style: solid;\n  border-color: ', ';\n  border-radius: 4px;\n  background-color: ', ';\n  &:hover {\n    border-color:', '\n  }\n']),
    _templateObject7 = (0, _taggedTemplateLiteral3.default)(['\n  font-family: ', ';\n  font-size: ', 'px;\n  line-height: ', 'px;\n  padding-right: ', ';\n  outline: none;\n  border: none;\n  background: transparent;\n  padding: 15px 18px;\n  color: ', ';\n'], ['\n  font-family: ', ';\n  font-size: ', 'px;\n  line-height: ', 'px;\n  padding-right: ', ';\n  outline: none;\n  border: none;\n  background: transparent;\n  padding: 15px 18px;\n  color: ', ';\n']),
    _templateObject8 = (0, _taggedTemplateLiteral3.default)(['\n  padding: 18px 0;\n'], ['\n  padding: 18px 0;\n']);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reset = require('../reset');

var reset = _interopRequireWildcard(_reset);

var _Body = require('../Text/Body');

var _Link = require('../Link/Link');

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Label = exports.Label = _Body.BodyComponent.extend(_templateObject, function (props) {
  return props.theme.textfield.labelColor;
});

var Toggle = exports.Toggle = _Body.BodyComponent.extend(_templateObject2, function (props) {
  return props.theme.text.link.color;
});

var ErrorText = exports.ErrorText = _Body.BodyComponent.extend(_templateObject3, function (p) {
  return p.theme.textfield.error.color;
});

var Caption = exports.Caption = _Body.BodyComponent.extend(_templateObject4);

var Link = exports.Link = _Link.LinkComponent.extend(_templateObject5);

var TextInputContainer = exports.TextInputContainer = reset.div(_templateObject6, function (p) {
  return p.theme.text.body.lineHeight + 30;
}, function (props) {
  if (props.disabled) {
    return props.theme.textfield.disabled.borderColor;
  }
  if (props.error) {
    return props.theme.textfield.error.borderColor;
  }
  if (props.isFocused) {
    return props.theme.textfield.focus.borderColor;
  }
  return props.theme.textfield.borderColor;
}, function (props) {
  return props.theme.colors.white;
}, function (props) {
  if (props.error || props.disabled || props.isFocused) return '';
  return props.theme.textfield.hover.borderColor;
});

var TextInput = exports.TextInput = reset.input.attrs({
  type: function type(p) {
    return p.type || 'text';
  }
})(_templateObject7, function (p) {
  return p.theme.text.fontFamily;
}, function (p) {
  return p.theme.text.body.fontSize;
}, function (p) {
  return p.theme.text.body.lineHeight;
}, function (p) {
  return p.toggle && '50px';
}, function (p) {
  return p.theme.text.body.color;
});

var TextFieldComponent = exports.TextFieldComponent = reset.div(_templateObject8);

var TextField = function TextField(props) {
  return _react2.default.createElement(TextFieldComponent, props);
};
exports.default = TextField;