import React from 'react';
import PropTypes from 'prop-types';
import * as reset from '../reset';

const Card = props => React.createElement(CardComponent, { active: props.active, width: props.width, height: props.height });

export const CardComponent = reset.div`
  margin: 18px 0;
  padding: 18px;
  border-radius: 6px;
  border-width: 1px;
  background-color: ${p => p.theme.colors.white}
  border-color: ${p => p.theme.colors.grey200}
  border-style: solid;
  width: ${p => p.width};
  height: ${p => p.height};
  box-shadow: ${p => p.active && '0px 3px 3px 0px rgba(0,0,0,0.05);'}
`;

Card.propTypes = process.env.NODE_ENV !== "production" ? {
  /**
   * Marks card as active
   */
  active: PropTypes.bool.isRequired,
  /**
   * Height css
   */
  height: PropTypes.string.isRequired,
  /**
   * Width css
   */
  width: PropTypes.string.isRequired
} : {};

Card.defaultProps = {
  active: false,
  height: '100%',
  width: '100%'
};

export default Card;