import _extends from 'babel-runtime/helpers/extends';
import React, { Component } from 'react';
import PropTypes from 'prop-types';
import { Select, Option, DropdownContainer, OptionsContainer, OptionsScrollContainer, Mask } from './DropdownComponents';
import { Label } from '../TextField/TextFieldComponents';

var _ref = React.createElement(
  Option,
  null,
  'No results'
);

class Dropdown extends Component {
  constructor(props) {
    super(props);

    this.handleToggle = () => {
      this.setState({
        isOpen: !this.state.isOpen
      });
    };

    this.select = value => {
      this.setState({
        value,
        isOpen: false
      });
    };

    this.handleMaskClick = () => {
      this.setState({
        isOpen: false
      });
    };

    this.state = {
      isOpen: false,
      value: null
    };
  }

  render() {
    const { label, data, width } = this.props;
    const { isOpen, value } = this.state;
    return React.createElement(
      DropdownContainer,
      { width: width },
      React.createElement(Mask, { show: isOpen, onClick: this.handleMaskClick }),
      label && React.createElement(
        Label,
        null,
        label
      ),
      React.createElement(Select, _extends({ isOpen: isOpen, value: value }, this.props, { onClick: this.handleToggle })),
      React.createElement(
        OptionsContainer,
        { size: data.length, hasLabel: !!label, show: isOpen },
        React.createElement(
          OptionsScrollContainer,
          null,
          data.length < 1 && _ref,
          data.map(d => React.createElement(
            Option,
            { data: d, onClick: () => this.select(d) },
            d.name
          ))
        )
      )
    );
  }
}

Dropdown.propTypes = process.env.NODE_ENV !== "production" ? {
  data: PropTypes.array.isRequired,
  label: PropTypes.string,
  placeholder: PropTypes.string,
  width: PropTypes.string
} : {};

Dropdown.defaultProps = {
  data: [],
  placeholder: 'Choose'
};

export default Dropdown;