import React from 'react';
import PropTypes from 'prop-types';

const SvgWrapper = ({ width, height, title, desc, children, viewBox }) => React.createElement(
  'svg',
  { width: width, height: height, viewBox: viewBox },
  React.createElement(
    'title',
    null,
    title
  ),
  React.createElement(
    'desc',
    null,
    desc
  ),
  children
);

SvgWrapper.propTypes = process.env.NODE_ENV !== "production" ? {
  /**
   * SVG content
   */
  children: PropTypes.node.isRequired,
  /**
   * SVG description
   */
  desc: PropTypes.string,
  /**
   * Height of svg
   */
  height: PropTypes.number,
  /**
   * SVG title
   */
  title: PropTypes.string,
  /**
   * View Box of svg
   */
  viewBox: PropTypes.string,
  /**
   * Width of svg
   */
  width: PropTypes.number
} : {};

SvgWrapper.defaultProps = {
  width: '50',
  height: '50'
};

export default SvgWrapper;