export default (({ typography, colors, spacing }) => {
  return {
    base: {
      borderRadius: 27,
      fontSize: typography.regular.size,
      lineHeight: typography.regular.lineHeight,
      fontWeight: 'bold',
      minWidth: '150px',
      paddingTop: `${spacing.paddingVertical}px`,
      paddingBottom: `${spacing.paddingVertical}px`,
      paddingLeft: `${spacing.paddingHorizontalRounded}px`,
      paddingRight: `${spacing.paddingHorizontalRounded}px`,
      marginTop: `${spacing.marginVertical}px`,
      marginBottom: `${spacing.marginVertical}px`,
      borderWidth: '1px',
      borderStyle: 'solid'
    },
    standard: {
      backgroundColor: colors.white,
      borderColor: colors.brand100,
      // Text color
      color: colors.brand100,
      hover: {
        // Fill
        backgroundColor: colors.brand50,
        borderColor: colors.brand100,
        // Text color
        color: colors.brand100
      },
      active: {
        // Fill
        backgroundColor: colors.brand300,
        borderColor: colors.brand300,
        // Text color
        color: colors.white
      },
      disabled: {
        // Fill
        backgroundColor: colors.grey100,
        borderColor: colors.grey200,
        // Text color
        color: colors.grey400
      }
    },
    primary: {
      backgroundColor: colors.brand100,
      borderColor: colors.brand100,
      // Text color
      color: colors.white,
      hover: {
        // Fill
        backgroundColor: colors.brand200,
        borderColor: colors.brand200,
        // Text color
        color: colors.white
      },
      active: {
        // Fill
        backgroundColor: colors.brand300,
        borderColor: colors.brand300,
        // Text color
        color: colors.white
      },
      disabled: {
        // Fill
        backgroundColor: colors.grey100,
        borderColor: colors.grey200,
        // Text color
        color: colors.grey400
      }
    }
  };
});